init offset = 1

init 1:
    style choice_button:
        background None

    style choice_button_text:
        idle_color "#FFFFFF"
        hover_color "#FFFFFF"
        insensitive_color "#808080FF"
        idle_outlines [ (absolute(4), "#FFF0", absolute(1), absolute(1)), (absolute(2), "#000", absolute(1), absolute(1)) ]
        hover_outlines [ (absolute(4), "#D376D7", absolute(1), absolute(1)), (absolute(2), "#000", absolute(1), absolute(1)) ]
        insensitive_outlines [ (absolute(4), "#808080C0", absolute(1), absolute(1)), (absolute(2), "#000", absolute(1), absolute(1)) ]

screen choice(items):

    style_prefix "choice"

    vbox:
        yalign 0.6
        spacing 10
        for n, i in enumerate(items, 1):

            $ hint = i.kwargs.get("hint", "none")

            # hbox:
            #     if persistent.menu_hints and is_there_a_hint(hint) and not _in_replay:
            #         xanchor 1.0
            #         xpos 1250
            #         spacing 60
            #         imagebutton:
            #             auto "images/utilities/icons/menu_hint_%s.webp"
            #             yalign 0.5
            #             action (Function(hide_hover_notify), i.action)
            #             hovered Function(show_menu_hint, hint)
            #             unhovered Function(hide_hover_notify)
            #             activate_sound audio.sfx_ui_choice_knob_click
            #             hover_sound audio.sfx_ui_choice_knob_hover
            #     else:
            #         xanchor 0.5
            #         xalign 0.5
            #         spacing 60

            key str(n) action i.action
            key "K_KP" + str(n) action i.action
            textbutton str(n) + ". " + i.caption action i.action

screen input(prompt):
    style_prefix "input"


    window:

        vbox:
            xalign gui.dialogue_text_xalign
            xpos gui.dialogue_xpos
            xsize gui.dialogue_width
            ypos gui.dialogue_ypos

            text prompt style "input_prompt" outlines [ (2, "#000000F0", 1, 1) ]
            input id "input" outlines [ (2, "#000000F0", 1, 1) ]

        background Transform(style.window.background, alpha = 1 - persistent.textbox_transparency)


screen say(who, what):
    style_prefix "say"

    window:
        id "window"
        background Transform(style.window.background, alpha = 1 - persistent.textbox_transparency)

        if who is not None:

            window:
                id "namebox"
                style "namebox"
                text who id "who"

        text what id "what" size persistent.pref_text_size


    if not renpy.variant("small"):
        add SideImage() xalign 0.0 yalign 1.0


screen preferences():
    tag menu

    use game_menu(_(""), scroll="viewport"):

        vbox:

            hbox:
                box_wrap True

                if renpy.variant("pc") or renpy.variant("web"):

                    vbox:
                        style_prefix "radio"
                        label _("Display")
                        textbutton _("Window") action Preference("display", "window")
                        textbutton _("Fullscreen") action Preference("display", "fullscreen")

                vbox:
                    style_prefix "radio"
                    label _("Rollback Side")
                    textbutton _("Disable") action Preference("rollback side", "disable")
                    textbutton _("Left") action Preference("rollback side", "left")
                    textbutton _("Right") action Preference("rollback side", "right")

                vbox:
                    style_prefix "check"
                    label _("Skip")
                    textbutton _("Unseen Text") action Preference("skip", "toggle")
                    textbutton _("After Choices") action Preference("after choices", "toggle")
                    textbutton _("Transitions") action InvertSelected(Preference("transitions", "toggle"))


            null height (4 * gui.pref_spacing)

            hbox:
                style_prefix "slider"
                box_wrap True

                vbox:

                    label _("Text Speed")

                    bar value Preference("text speed")

                    label _("Auto-Forward Time")

                    bar value Preference("auto-forward time")

                    label _("Textbox Transparency")

                    bar value FieldValue(persistent, "textbox_transparency", range=1.0, style="slider")

                    label _("Text Size: %s" % (persistent.pref_text_size))

                    bar value FieldValue(object=persistent, field='pref_text_size', range=(gui.text_size * 2), max_is_zero=False, style=u'slider', offset=0, step=1)

                vbox:

                    if config.has_music:
                        label _("Music Volume")

                        hbox:
                            bar value Preference("music volume")

                    if config.has_sound:

                        label _("Sound Volume")

                        hbox:
                            bar value Preference("sound volume")

                            if config.sample_sound:
                                textbutton _("Test") action Play("sound", config.sample_sound)


                    if config.has_voice:
                        label _("Voice Volume")

                        hbox:
                            bar value Preference("voice volume")

                            if config.sample_voice:
                                textbutton _("Test") action Play("voice", config.sample_voice)

                    if config.has_music or config.has_sound or config.has_voice:
                        null height gui.pref_spacing

                        textbutton _("Mute All"):
                            action Preference("all mute", "toggle")
                            style "mute_all_button"

init python:
    def _toggle_quick_menu_q():

        if renpy.has_screen('quick_menu'):
            if not hasattr(store, 'quick_menu'):
                setattr(store, 'quick_menu', True)
                renpy.show_screen('quick_menu')
                setattr(store, 'suppress_overlay', False)
            else:
                if quick_menu == True:
                    setattr(store, 'quick_menu', False)
                    renpy.hide_screen('quick_menu')
                else:
                    setattr(store, 'quick_menu', True)
                    renpy.show_screen('quick_menu')
                    setattr(store, 'suppress_overlay', False)

    config.keymap[ 'toggle_quick_menu_q' ] = [ 'K_q' ]
    config.underlay.append(renpy.Keymap(toggle_quick_menu_q = Function(_toggle_quick_menu_q)))